<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>1712480</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
    <script src="https://kit.fontawesome.com/50227afacd.js" crossorigin="anonymous"></script>
    <style>
        a:hover{
            cursor: pointer;
            background-color: rgb(211, 211, 211);
            transition: 0.3s ease;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-light bg-light">
        <a class="nav-link" href="main.html"><i class="fas fa-home"></i>  TRANG CHỦ</a>
    </nav>
    
    <div class="container-fluid" style="min-height: 100vh;">
        <div class="row justify-content-around" id="main">
            <!-- chi tiết phim -->
        </div>
    </div>
    <div class="row justify-content-around">
        <div class="col-md-8">
            <div class="row justify-content-around" id="review">
                <!-- review phim -->
            </div>
        </div>
    </div>

    <div class="navbar navbar-light bg-light text-muted">
        Footer
    </div>

    <script>
        var id = decodeURIComponent(window.location.search);
        id = id.substring(4); 
        var root = 'https://api.themoviedb.org/3'
        var image = 'https://image.tmdb.org/t/p/w500';
        var apiKey = '72f2c8d144e53a3a45806d7138a530f8';
        var director, genres = [], cast = [], castID = [], reviews = [];

        // hiệu ứng loading
        function loading(){
            $('#main').empty();
            $('#main').append(`
                <div class="spinner-border" role="status">
                    <span class="sr-only">Loading...</span>
                </div>
            `);
        }

        // điền các review vào danh sách
        function fillReviews(reviews){
            for (var review of reviews.results){
                $('#review').append(`
                <div class="card">
                    <div class="card-header">Review</div>
                    <div class="card-body">
                        <blockquote class="blockquote mb-0">
                            <p>${review.content}</p>
                            <footer class="blockquote-footer">${review.author}</footer>
                        </blockquote>
                    </div>
                </div>
                `);
            }
        }
        
        //  lấy review từ API
        async function getReviews(){
            const response = await fetch(`${root}/movie/${id}/reviews?api_key=${apiKey}`);
            const result = await response.json();

            fillReviews(result);
        }

        // điền đạo diễn và diễn viên
        function fillDirectorAndCasts(){
            var castList = "";

            for (var i=0; i < cast.length; i++){
                castList += `<a onclick="detailCast(${castID[i]})">${cast[i]}</a>` + `, `;
            }

            $('#cast').append(castList);
            $('#director').append(director);

            getReviews();
        }

        // lấy đạo diễn và diễn viên từ API vì trong data ban đầu không có thông tin này
        async function getDirectorAndCasts(){
            const response = await fetch(`${root}/movie/${id}/credits?api_key=${apiKey}`);
            const result = await response.json();
            // tìm người trong đội ngũ sản xuất có công việc là "Director"
            for (var crew of result.crew){
                if (crew.job == 'Director'){
                    director = crew.name;
                }
            }

            // lấy danh sách tên và ID của diễn viên
            for (var star of result.cast){
                cast.push(star.name);
                castID.push(star.id);
            }

            fillDirectorAndCasts();
        }

        function fillDetailFilm(film){
            // lấy mảng thể loại
            for (var genre of film.genres){
                genres.push(genre.name);
            }
            $('#main').empty();
            $('#main').append(`
            <div class="col-md-1"></div>
            <div class="col-md-5 details">
                <blockquote>
                    <h1 class="display-4">${film.title}</h1>
                    <small><cite tiltle="Ngày ra mắt:">${film.release_date}</cite></small>
                </blockquote>
                <div>
                    <h5>Tóm tắt:</h5>
                    <p>${film.overview}</p>
                </div>
                
                <div>
                    <h5>Đạo diễn:</h5>
                    <p id="director"></p>
                </div>

                <div>
                    <h5>Thể loại:</h5>
                    <p>${genres}</p>
                </div>

                <div>
                    <h5>Diễn viên:</h5>
                    <p id="cast"></p>
                </div>
            </div>
            <div class="col-md-5 img">
                <img src="${image + film.poster_path}"  alt="${film.title}">
            </div>
            `);

            getDirectorAndCasts();
        }

        // lấy data ban đầu, bao gồm tên phim, poster, thời điểm ra mắt, thể loại, tóm tắt
        async function getDetail(){
            loading();

            const response = await fetch(`${root}/movie/${id}?api_key=${apiKey}`);
            const film = await response.json();

            fillDetailFilm(film);
        }

        // hàm mở trang thông tin diễn viên khi người dùng nhấp chuột vào tên diễn viên
        function detailCast(id){
            window.open("detailCast.html" + "?id=" + id);
        }

        $(document).ready(function(){
            getDetail();
        });
    </script>
</body>
</html>